services:
  - name: docker:dind
    entrypoint: ["env", "-u", "DOCKER_HOST"]
    command: ["dockerd-entrypoint.sh"]

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""
  REGISTRY_HOST: 
  IMAGE_TAG: 

stages:
  - build
  - deploy

.build:
  stage: build
  image:
    name: docker:stable
  script:
    - docker login https://${REGISTRY_HOST}
    - docker build --tag ${IMAGE_TAG}:${CI_PIPELINE_ID} --tag ${IMAGE_TAG}:${CI_COMMIT_BRANCH} .
    - docker push ${IMAGE_TAG}:${CI_PIPELINE_ID}
    - docker push ${IMAGE_TAG}:${CI_COMMIT_BRANCH}

.deploy:
  stage: deploy
  image:
    name: dtzar/helm-kubectl
  script:
    - mkdir ~/.kube && echo $KUBE_CONFIG_PROD | base64 -d > ~/.kube/config 
    - helm upgrade --install -n ${CI_ENVIRONMENT_NAME} ${CI_PROJECT_NAME}-${CI_ENVIRONMENT_NAME} ./.helm -f ./.helm/values.yaml --set "ingress.hosts[0]=${CI_PROJECT_NAME}.${DOMAIN}" --set releaseOverride=$RELEASE_NAME --set image.repository="${IMAGE_TAG}" --set image.tag=${CI_PIPELINE_ID}

build-prod:image:
  extends: .build-prod
  environment:
    name: Prod
  tags:
    - helm-push
  only:
    - master

deploy-prod:image:
  extends: .deploy-prod
  environment:
    name: prod
  tags:
    - helm-push
  only:
    - master    
